import React from 'react';
import { resolveJSXElement, rclassnames } from '@reboot-ui/common';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

/**
 * @see https://getbootstrap.com/docs/4.4/components/button-group
 */

function ButtonGroup(_a) {
  var children = _a.children,
      _b = _a.as,
      _as = _b === void 0 ? 'div' : _b,
      size = _a.size,
      _c = _a.vertical,
      vertical = _c === void 0 ? false : _c,
      _d = _a.toggle,
      toggle = _d === void 0 ? false : _d,
      props = __rest(_a, ["children", "as", "size", "vertical", "toggle"]);

  var JSXEl = resolveJSXElement(_as, {
    allowedHTMLTags: ['div']
  });

  switch (size) {
    case 'lg':
    case 'sm':
      break;

    default:
      size = undefined;
      break;
  }

  return React.createElement(JSXEl, _extends({}, props, {
    className: rclassnames(props, ["btn-group" + (vertical ? '-vertical' : ''), size && "btn-group-" + size, toggle && "btn-group-toggle"]),
    role: "group"
  }), children);
}

export default ButtonGroup;
